﻿Type=Class
Version=1.8
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	Private CatEd As TextField
	Private CatTV As TableView
	Private CIDs As Int	
	Private SelRow As Int
	Private TheCat As String
	Public SelItemIndex As Int		' Used in Edit/Delete
	Private IsEdits As Boolean
	Private Message, Title As String
	Private Msgbox As AlertForm
	Private AddCatBtn As Button
	Private DeleteBtn As Button
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)
	frm.Initialize("frm", 515, 385)
	frm.Title = "Categories"
	frm.SetFormStyle("UTILITY")
	frm.Resizable = False
	frm.RootPane.LoadLayout("Category")
	frm.SetOwner(Parent)
	
	Msgbox.Initialize(frm)

	SetupTableView
	IsEdits = False
	SelRow = 0	
	FillList
End Sub

' Load the Categories into the CatTV Table View
Private Sub FillList	
	Dim CatLst As List
	
	CatLst.Initialize

	' empty the CatTV Table View of all its items
	CatTV.Items.Clear
	
	' Load the Categories Table into the CatTV Table View
	DBUtils.LoadTableView(Main.SQL1, "SELECT CId, [Categories] FROM Categories ORDER BY [Categories]", Null, 0, CatTV)
	
	If CatTV.Items.Size > 0 Then
		CatTV.SelectedRow = SelRow
		
		CatLst = CatTV.SelectedRowValues
		CIDs = CatLst.Get(0)
		TheCat = CatLst.Get(1)
	Else
		CIDs = -1
		TheCat = ""
		SelItemIndex = -1
	End If
	
End Sub

Public Sub Show
	' new - Steve105 18/03/2014
	frm.WindowLeft = Main.loc.left + (Main.loc.width - frm.Width) / 2
	frm.WindowTop = Main.loc.top + (Main.loc.height - frm.Height) / 2

	frm.ShowAndWait
End Sub

' Add a new Category to the Categories Table
Private Sub AddCatBtn_Action
	Dim Cat As String
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	
	Dim  loc As locs
	loc.Initialize
	loc.left = frm.WindowLeft
	loc.width = frm.WindowWidth
	loc.top = frm.WindowTop
	loc.height = frm.WindowHeight
	
	Cat = CatEd.Text
	If Cat = "" Then
		Message = "Enter a Category!"
		Title = "Data Entry Error"
		Msgbox.Show(1, Message, Title, loc)
		CatEd.RequestFocus
		Return
	End If
	
	' If not in Edit Mode then save
	If IsEdits = False Then
		Dim m As Map
		m.Initialize
		m.Put("CId", Null)
		m.Put("Categories", Cat)
		
		ListOfMaps.Add(m)

		DBUtils.InsertMaps(Main.SQL1, "Categories", ListOfMaps)
		
		ListOfMaps.Clear
	Else
		' In Edit mode - Update record
		' update record	
		Dim WhereFields As Map
		WhereFields.Initialize
		WhereFields.Put("CId", CIDs)
		DBUtils.UpdateRecord(Main.SQL1, "Categories", "Categories", Cat, WhereFields)
		
		' Set elements back to Not Edit Mode
		IsEdits = False
		AddCatBtn.Text = " Add Category"
		DeleteBtn.Enabled = True
	End If
		
	FillList
		
	CatEd.Text = ""
End Sub

' Delete a Category and all its Items
Private Sub DeleteBtn_Action
	Dim sb As StringBuilder
	Dim Qry1 As String
	Dim Message, Title As String
	Dim result As Int
	
	Dim  loc As locs
	loc.Initialize
	loc.left = frm.WindowLeft
	loc.width = frm.WindowWidth
	loc.top = frm.WindowTop
	loc.height = frm.WindowHeight
	
	If SelItemIndex < 0 Then Return		' no category selected

	' message
	Qry1 = ""
	sb.Initialize
	sb.Append("Deleting ").Append(TheCat).Append(" will delete all its Items as well").Append(CRLF).Append("CONTINUE ?")
	Message = sb.ToString
	Title = "Delete Category and Items"
	result = Msgbox.Show(2, Message, Title, loc)
	If result = 1 Then
		' Delete the Items from Items dbase using CIDs
		Qry1 = "DELETE FROM Items WHERE CId = " & CIDs
		Main.SQL1.ExecNonQuery(Qry1)
		' Delete the Selected Category
		Qry1 = "DELETE FROM Categories WHERE CId = " & CIDs
		Main.SQL1.ExecNonQuery(Qry1)
		' Reload the TableView
		SelRow = 0
		FillList
	End If
End Sub	
	
' Selecting a Row in the CatTV Table View
Private Sub CatTV_SelectedRowChanged(Index As Int, Row() As Object)
	' get SelRaceID
	If Index = -1 Then 
		SelItemIndex = -1
		Return
	End If
	SelRow = Index
	CIDs = Row(0) 'CId is the first column
	TheCat = Row(1)
	SelItemIndex = Index
	If IsEdits Then
		IsEdits = False
		DeleteBtn.Enabled = True
		AddCatBtn.Text = " Add Category"
		CatEd.Text = ""
	End If	
End Sub

' Setup the Categories Table View (CatTV)
Private Sub SetupTableView
	Dim CList As List
	
	CList.Initialize
	CList.Add("CId")
	CList.Add("Category")
	CatTV.SetColumns(CList)

	CatTV.SetColumnVisible(0,False)	' CId
	CatTV.SetColumnWidth(1, 224.0)	' Category

	CList.Clear
End Sub

' Edit a Category name
Private Sub EditCatBtn_Action
	If SelItemIndex < 0 Then Return		' no category selected
	IsEdits = True
	DeleteBtn.Enabled = False
	
	' Put selected Category Name into the Edit control
	CatEd.Text = TheCat
	' Change Add Category button text to show 'Save Edit'
	AddCatBtn.Text = "Save Edit"
End Sub



