﻿Type=Class
Version=1.8
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	Private Msgbox As AlertForm
	Private Message, Title As String
	Private ItemDescEd As TextField
	Private DataEditEd As TextArea
	Private IIDx As Int
	Private Reps As Int
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)
	frm.Initialize("frm", 800, 600)
	frm.Title = "Edit a Record"
	frm.SetFormStyle("UTILITY")
	frm.Resizable = False
	frm.RootPane.LoadLayout("EditRec")
	frm.SetOwner(Parent)	
	
	Msgbox.Initialize(frm)

	LoadInfo
End Sub

' Load the record to be edited
Private Sub LoadInfo
	Dim Cols() As String

	' Load the Item and Blob for this Item
	Cols = Main.ItemsList.Get(Main.SelItemIndex)
	IIDx = Cols(0)
	ItemDescEd.Text = Cols(2) 
	DataEditEd.Text = Cols(3)
End Sub

Public Sub Show As Int
	frm.WindowLeft = Main.loc.left + (Main.loc.width - frm.Width) / 2
	frm.WindowTop = Main.loc.top + (Main.loc.height - frm.Height) / 2

	frm.ShowAndWait
	If Reps = 1 Then
		Return 1
	Else
		Return 0
	End If
End Sub

Private Sub CancelEditBtn_Action
	Reps = 0
	frm.Close
End Sub

' Save the edited Record
Private Sub SaveEditBtn_Action
	Dim  loc As locs
	
	loc.Initialize
	loc.left = frm.WindowLeft
	loc.width = frm.WindowWidth
	loc.top = frm.WindowTop
	loc.height = frm.WindowHeight

	' check valid data in Edits
	If ItemDescEd.text = "" Then
		Message = "Enter an Item Description!"
		Title = "Data Entry Error"
		Msgbox.Show(1, Message, Title, loc)
		ItemDescEd.RequestFocus
		Return
	End If	
	
	If DataEditEd.Text = "" Then
		Message = "Enter Data for this Item!"
		Title = "Data Entry Error"

		Msgbox.Show(1, Message, Title, loc)
		DataEditEd.RequestFocus
		Return
	End If	
	
	' update record
	Dim Fld As Map
	Fld.Initialize
	Fld.Put("Items", ItemDescEd.text)
	Fld.Put("Data", DataEditEd.Text)
	
	Dim WhereFields As Map
	WhereFields.Initialize
	WhereFields.Put("IId", IIDx)
	DBUtils.UpdateRecord2(Main.SQL1, "Items", Fld, WhereFields)
	
	Reps = 1
	frm.Close
End Sub

Private Sub frm_CloseRequest (EventData As Event)
	Reps = 0
End Sub