﻿Type=Class
Version=1.8
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private ifrm As Form
	Private CatCmb As ComboBox
	Private CIDs As Int	
	Private Msgbox As AlertForm
	Private ItemEd As TextField
	Private DataEd As TextArea
	Private NewCat As String
	Private Message, Title As String
	Private CatLst As List
	Private DisplayItemFrm As ShowItemForm
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)
	ifrm.Initialize("frm", 800, 550)
	ifrm.Title = "Items and Data"
	ifrm.SetFormStyle("UTILITY")
	ifrm.Resizable = False
	ifrm.RootPane.LoadLayout("Items")
	ifrm.SetOwner(Parent)
	
	NewCat = ""
	CIDs = -1
	DataEd.Style = "-fx-font-size: 15px;"
	
	Msgbox.Initialize(ifrm)
	
	LoadCategories
End Sub

Public Sub Show
	ifrm.WindowLeft = Main.loc.left + (Main.loc.width - ifrm.Width) / 2
	ifrm.WindowTop = Main.loc.top + (Main.loc.height - ifrm.Height) / 2

	ifrm.ShowAndWait
End Sub

' Load the Categories from the Categories Table into the Combobox
Private Sub LoadCategories
	Dim Qry1 As String
	Dim Cols() As String
	
	' Get Categories from Categories Dbase into CatLst
	' CatLst is kept to refernce data in the List
	Qry1 = "SELECT * FROM Categories ORDER BY [Categories]"
	CatLst = DBUtils.ExecuteMemoryTable(Main.SQL1, Qry1, Null, 0)
	
	CatCmb.Items.Clear
	' Work through the list of Categories
	For i = 0 To CatLst.Size - 1
		Cols = CatLst.Get(i)
		CatCmb.Items.Add(Cols(1))
	Next
End Sub

' Add New Item or Edit Item
Private Sub AddBtn_Action
	Dim IsOk As Boolean
	
	IsOk = ValidateCategory
	
	If IsOk Then
		WorkAddData
	End If
End Sub

Private Sub ValidateCategory As Boolean
	Dim IsOk As Boolean
	Dim IsNewCat As Boolean
	Dim idx As Int
	Dim Cols() As String
	Dim  loc As locs
	
	loc.Initialize
	loc.left = ifrm.WindowLeft
	loc.width = ifrm.WindowWidth
	loc.top = ifrm.WindowTop
	loc.height = ifrm.WindowHeight
	
	IsOk = True
	' check for valid data in Cmb
	If CIDs < 1 Then
		If NewCat = "" Then	
			Message = "Select a Category!"
			Title = "Data Entry Error"
'			Msgbox.DialogType = "ERROR"
'			Msgbox.SetXY(ifrm.WindowLeft+300, ifrm.WindowTop+200)
			Msgbox.Show(1, Message, Title, loc)
			IsOk = False
		Else
			' check category exists
			' Work through the list of Categories
			IsNewCat = True
			For i = 0 To CatLst.Size - 1
				Cols = CatLst.Get(i)
				If Cols(1) = NewCat Then
					IsNewCat = False
					CIDs = Cols(0)
					' Select origCat in the Cmb
					idx = CatCmb.Items.IndexOf(NewCat)
					CatCmb.SelectedIndex = idx	
					
'					' Check if the ShowItemForm is displayed
					CheckCurItemDisplay
				End If
			Next
		
			If IsNewCat Then
				AddNewCat
			End If
		End If
	End If
	Return IsOk
End Sub

Private Sub WorkAddData
	Dim ListOfMaps As List
	ListOfMaps.Initialize
	Dim Item, Datas As String
	Dim loc As locs
	
	loc.Initialize
	loc.left = ifrm.WindowLeft
	loc.width = ifrm.WindowWidth
	loc.top = ifrm.WindowTop
	loc.height = ifrm.WindowHeight

	Item = ItemEd.Text
	If Item = "" Then
		Message = "Enter an Item Description!"
		Title = "Data Entry Error"
		Msgbox.Show(1, Message, Title, loc)
		ItemEd.RequestFocus
		Return
	End If	
	
	Datas = DataEd.Text
	If Datas = "" Then
		Message = "Enter Data for this Item!"
		Title = "Data Entry Error"
		Msgbox.Show(1, Message, Title, loc)
		DataEd.RequestFocus
		Return
	End If	
	
	' Ok to save to Items Database
	Dim m As Map
	m.Initialize
	m.Put("IId", Null)
	m.Put("CId", CIDs)
	m.Put("Items", Item)
	m.Put("Data", Datas)
	
	ListOfMaps.Add(m)

	DBUtils.InsertMaps(Main.SQL1, "Items", ListOfMaps)

	ListOfMaps.Clear
	
	ItemEd.Text = ""
	DataEd.Text = ""
	
	' new - Steve105 18/03/2014
	' Check if the ShowItemForm is displayed
	If DisplayItemFrm.IsInitialized Then
		If DisplayItemFrm.IsFormVisible Then
			' update the Items in the ShowItemForm
			DisplayItemFrm.SetCids(CIDs)
		End If
	End If	
End Sub

Private Sub AddNewCat
	Dim col2() As String
	Dim idx As Int
	Dim ListOfMaps As List
	ListOfMaps.Initialize	
	
	' add to Categories
	Dim m As Map
	m.Initialize
	m.Put("CId", Null)
	m.Put("Categories", NewCat)
	ListOfMaps.Add(m)
	DBUtils.InsertMaps(Main.SQL1, "Categories", ListOfMaps)
	ListOfMaps.Clear
		
	LoadCategories
	
	' Work through the list of Categories to get CIDs
	For i = 0 To CatLst.Size - 1
		col2 = CatLst.Get(i)
		If col2(1) = NewCat Then
			CIDs = col2(0)
		End If
	Next
	
	' Select NewCat in the Cmb
	idx = CatCmb.Items.IndexOf(NewCat)
	CatCmb.SelectedIndex = idx
End Sub

' make selection in Catagories combobox
Private Sub CatCmb_SelectedIndexChanged(Index As Int, Value As Object)
	Dim Cols() As String
	
	If Index = -1 Then Return
	Cols = CatLst.Get(Index)
	CIDs = Cols(0)
	NewCat = ""

	' Check if the ShowItemForm is displayed
	CheckCurItemDisplay
End Sub

Sub CatCmb_ValueChanged (Value As Object)
	NewCat = Value
	CIDs = -1
End Sub

Private Sub frm_CloseRequest(EventData As Event)
    CatLst.Clear
End Sub

' Display the Current Items for the Selected Category
Private Sub CurItemsBtn_Action
	DisplayItemFrm.Initialize(ifrm, CIDs)
	DisplayItemFrm.Show
End Sub

Private Sub CheckCurItemDisplay
	' Check if the ShowItemForm is displayed
	If DisplayItemFrm.IsInitialized Then
		If DisplayItemFrm.IsFormVisible Then
			' update the Items in the ShowItemForm
			DisplayItemFrm.SetCids(CIDs)
		End If
	End If
End Sub
