﻿Type=Class
Version=1.8
B4J=true
@EndOfDesignText@
'Class module
Sub Class_Globals
	Private fx As JFX
	Private frm As Form
	Private SearchEd As TextField
	Private ItemsRBtn As RadioButton
	Private DataRBtn As RadioButton
	Private SearchList As List
	Private ItemsFoundTV As TableView
	Private DataBlobEd As TextArea
	Private Msgbox As AlertForm
	Private Message, Title As String
	Private CatNameLbl As Label
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(Parent As Form)
	frm.Initialize("frm", 800, 700)
	frm.Title = "Search"
	frm.RootPane.LoadLayout("Search")
	frm.SetOwner(Parent)	
	
	frm.SetWindowSizeLimits(600.0dip, 500.0dip, 1200.0dip, 980.0dip)

	Msgbox.Initialize(frm)
	
	SetupTableView
	
	DataBlobEd.Style = "-fx-font-size: 15px;"
	DataBlobEd.Editable = False
End Sub

Private Sub frm_Resize (Width As Double, Height As Double)
	ItemsFoundTV.SetColumnWidth(2, Width - 270.0)	' Category
End Sub

Public Sub Show
	frm.WindowLeft = Main.loc.left + (Main.loc.width - frm.Width) / 2
	frm.WindowTop = Main.loc.top + (Main.loc.height - frm.Height) / 2

	frm.ShowAndWait
End Sub

' Row selected in Items Found List
Private Sub ItemsFoundTV_SelectedRowChanged(Index As Int, Row() As Object)
	Dim Cols() As String

	DataBlobEd.Text = ""
	If Index = -1 Then Return
	
	' Load the Blob for this Item
	Cols = SearchList.Get(Index)
	DataBlobEd.Text = Cols(3)	
	
	' look up Category for selected Row in Found Items List
	LookUpCID(Cols(1))
End Sub

Private Sub SearchBtn_Action
	Dim SearchFor As String
	Dim Qry1 As String
	Dim Cols() As String
	Dim  loc As locs
	
	loc.Initialize
	loc.left = frm.WindowLeft
	loc.width = frm.WindowWidth
	loc.top = frm.WindowTop
	loc.height = frm.WindowHeight
	
	CatNameLbl.Text = ""		' Emtpy Category label for the selected Item
	
	' check for SearchEd contents
	SearchFor = SearchEd.Text
	If SearchFor = "" Then
		Message = "Enter Text to search for"
		Title = "Data Entry Error"
		Msgbox.Show(1, Message, Title, loc)
		SearchEd.RequestFocus
		Return
	End If	
	' which radio button is active
	' search is Case Insensitive...(using LIKE)
	If ItemsRBtn.Selected = True Then
		' search through all the 'Items field' in Items Table for the Text
		Qry1 = "SELECT * FROM Items WHERE [Items] LIKE '%" & SearchFor & "%'"
		SearchList = DBUtils.ExecuteMemoryTable(Main.SQL1, Qry1, Null, 0)		
	Else
		' search through all the 'Data field' in Items Table for the Text
		Qry1 = "SELECT * FROM Items WHERE [Data] LIKE '%" & SearchFor & "%'"
		SearchList = DBUtils.ExecuteMemoryTable(Main.SQL1, Qry1, Null, 0)	
	End If
	ItemsFoundTV.Items.Clear
	' Work through the list of Items and put them into the Items Found TableView
	For i = 0 To SearchList.Size - 1
		Cols = SearchList.Get(i)
		ItemsFoundTV.Items.Add(Array As String(Cols(0),Cols(1),Cols(2)))
	Next
End Sub

	' Setup Categories Table

Private Sub SetupTableView
	Dim CList As List
	
	CList.Initialize
	
	' Setup Items Table
	CList.Add("IId")
	CList.Add("CId")
	CList.Add("Items")
	ItemsFoundTV.SetColumns(CList)
	
	ItemsFoundTV.SetColumnVisible(0,False)	' IId
	ItemsFoundTV.SetColumnVisible(1,False)	' CId
	ItemsFoundTV.SetColumnWidth(2, 533.0)	' Category
End Sub

' test - to get the Category of the clicked Item in the ItemTV
Private Sub LookUpCID(CidNo As String)
	Dim Qry1 As String
	Dim Cols() As String
	Dim AList As List
	
	AList.Initialize
	' Get Items from Items Dbase into ItemsList
	Qry1 = "SELECT * FROM Categories WHERE CId = " & CidNo
	AList = DBUtils.ExecuteMemoryTable(Main.SQL1, Qry1, Null, 0)
	
	If AList.Size > 0 Then
		Cols = AList.Get(0)
		CatNameLbl.Text = Cols(1)
	End If
	AList.Clear
End Sub
